precision highp float;
uniform sampler2D InputTextureSampler;
uniform float TimeInterval;
uniform float TimeElapse;
varying vec2 VSOutTexCoord;
void main() {
    const float PI = 3.1415926;
    float Time = TimeElapse/1000.0;
     //一次闪白滤镜的时长 0.8
    float duration = 0.8;
    float time = mod(Time, duration);
    //白色颜色遮罩层
    vec4 whiteMask = vec4(0.8,0.8,0.8, 1.0);
    //振幅: (0.0,1.0)
    float amplitude = abs(sin(time * (PI / duration)));
    //纹理坐标对应的纹素(RGBA)
    vec4 mask = texture2D(InputTextureSampler, VSOutTexCoord);
    
    //利用混合方程式; 白色图层 + 原始纹理图片颜色 来进行混合
    gl_FragColor = mask * (1.0 - amplitude) + whiteMask * amplitude;
}